/* Glftpd password verifier by Usurper, December 2000 version 1.0 */

char *passwdpath = "/glftpd/etc/passwd";

#include <stdio.h>

extern char *crypt();

int main (int argc, char *argv[]) {
	char *encrypted, pass[30], username[30], *boo;
	char buff[BUFSIZ], encpass[30], found=0;
	FILE *pw;
	
	if (argc < 3) {
	  printf("Glftpd password verifier by Usurper, December 2000, v1.0\n");
	  printf("Syntax: %s username unencrypted_password\n", argv[0]);
	  return 1;
	}
	strcpy(username, argv[1]);
	strcpy(pass, argv[2]);

	pw = fopen(passwdpath, "r");
	if (pw == NULL) {
	  printf("Can't open %s\n", passwdpath);
	  return 1;
	}
	while (fgets(buff, sizeof(buff), pw) != NULL) {
	  if (strncmp(buff, username, strlen(username)) == 0) {
	    strncpy(encpass, strchr(buff, ':') +1, sizeof(encpass));
	    boo = (char *)strchr(encpass, ':');
	    if (boo) *boo = '\0';
	    found++;
	    break;
	  }
	}
	fclose(pw);
	if (!found) {
	  printf("Can't find %s in %s\n", username, passwdpath);
	  return 1;
	}
	encrypted = crypt(pass, encpass);
	if (strcmp(encrypted, encpass) != 0) {
	  printf("No match.\n");
	  return 1;
	}
	printf("Match.\n");
	return 0;
}
